Linux解决Warning: mysql_connect(): Headers and client library minor version mismatch. 警告

版权说明 : Linux解决Warning: mysql_connect(): Headers and client library minor version mismatch. 警告于当前CSDN博客乘月网属同一原创,转载请说明出处,谢谢。


这两天用阿里云服务器重新部署网站服务器后,打开某php页面出现了如下警告:Warning: mysql_connect(): Headers and client library minor version mismatch. Headers:50547 Library:50631 in /XXX(某某目录)/wp-db.php on line 1520,虽然是警告,但是有的界面会因此打不开,甚是头疼,前不久用的是腾讯云服务器同样的部署方式并没有出现这个警告,一头雾水。

使用:

php -i|grep Client
查询当前Client 版本,结果如下:

Client API version => 5.6.31
Client API library version => 5.6.31
Client API header version => 5.5.47-MariaDB
Client API version => 5.6.31

好吧,header version => 5.5.47-MariaDB 出现个奇葩,版本号不一样,怪不得报错了。据某大牛说,版本不兼容,需升级MariaDB版本至少到5.6.31或许可以解决。我的系统是CentOS7.2版本,众所周知,CentOS从7.x系列版本开始抛弃了MySQL,缺省安装的是MariaDB,虽然MariaDB兼容MySQL,但是我还是比较喜欢MySQL,所以我给服务器强制安装了MySQL,也希望一直用下去,对于这个情况,升级MariaDB这条路是不能走了。考虑当前安装的是php-mysql驱动,而当前的php版本比较新,想到这个奇葩是不是因为驱动版本较低造成的,于是尝试以下操作:

yum remove php-mysql
yum install php-mysqlnd

先卸载较低版本的 php-mysql驱动,再升级安装新版的php-mysqlnd驱动。

OK,再重启下httpd和mysql服务:

systemctl  restart httpd
systemctl  restart mysqld
再打开网站,能正常打开,感觉可以了,再检测下那个奇葩:
php -i|grep Client
结果如下:

Client API version => mysqlnd 5.0.10 - 20111026 
Client API library version => mysqlnd 5.0.10 - 20111026 
Client API version => mysqlnd 5.0.10 - 20111026 

OK,版本全统一了,问题解决。


这里再添加一些小细节知识:

1.如果像我一样给CentOS7.x以上版本系统强制安装MySQL的朋友,在安装MySQL前最好能卸载或清除下MariaDB软件或文件,这里介绍下卸载方法,以我的系统为例:

先检查MariaDB所有的安装文件:

rpm -qa | grep "mariadb"
结果如下:

mariadb-libs-5.5.44-2.el7.centos.x86_64
卸载:

rpm -e mariadb-libs-5.5.44-2.el7.centos.x86_64
如果出现这样的错误:

依赖检测失败:

libmysqlclient.so.18()(64bit) 被 (已安裝) postfix-2:2.10.1-6.el7.x86_64 需要
libmysqlclient.so.18(libmysqlclient_18)(64bit) 被 (已安裝) postfix-2:2.10.1-6.el7.x86_64 需要 
那么加上“--nodeps”强制卸载:
rpm -e --nodeps mariadb-libs-5.5.44-2.el7.centos.x86_64


2.安装新版的MySQL是有默认密码的,在mysql执行日志里,不过需要先启动mysqld服务(生成mysql执行日志mysqld.log ),才能看到。所以安装后修改密码前应执行:

systemctl start mysqld
操作,再执行:
grep password /var/log/mysqld.log 
第一个检索的“password”后面root@localhost: 后面跟着的密码应该就是默认密码了。




阅读更多
个人分类: Linux
上一篇Linux SSH登录服务器报ECDSA host key "ip地址" for has changed and you have requested strict checking错误
下一篇解决ScrollView起始位置不是最顶部问题的3套方案
想对作者说点什么? 我来说一句

没有更多推荐了,返回首页

关闭
关闭
关闭